=== debian/changelog ===
openjpeg2 (2.3.1-1ubuntu4.20.04.4) focal-security; urgency=medium

  * SECURITY UPDATE: Heap buffer overflow.
    - debian/patches/CVE-2024-56826.patch: Add comp12w variable and
      comparisons in src/bin/common/color.c.
    - debian/patches/CVE-2024-56827.patch: Add l_current_tile_part comparison
      to check again total number of tile parts in src/bin/openjp2/j2k.c.
    - CVE-2024-56826
    - CVE-2024-56827

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Tue, 21 Jan 2025 12:27:28 -0330

openjpeg2 (2.3.1-1ubuntu4.20.04.3) focal-security; urgency=medium

  * SECURITY UPDATE: integer overflow
    - debian/patches/CVE-2021-29338-1.patch:
    opj_compress/opj_uncompress: fix integer overflow in num_images
    - debian/patches/CVE-2021-29338-2.patch: Avoid overflow in
      multiplications in utilities related to big number of files in a
      directory
    - CVE-2021-29338
  * SECURITY UPDATE: heap buffer overflow
    - debian/patches/CVE-2021-3575.patch: opj_decompress: fix off-by-one
      read heap-buffer-overflow in sycc420_to_rgb() when x0 and y0 are odd
    - CVE-2021-3575
  * SECURITY UPDATE: denial of service
    - debian/patches/CVE-2022-1122.patch: Fix segfault in
      src/bin/jp2/opj_decompress.c due to uninitialized pointer
    - CVE-2022-1122

 -- Bruce Cable <bruce.cable@canonical.com>  Tue, 22 Oct 2024 16:03:30 +1100

openjpeg2 (2.3.1-1ubuntu4.20.04.2) focal-security; urgency=medium

  * SECURITY UPDATE: resource consumption loop
    - debian/patches/CVE-2023-39327.patch: when EPH markers are specified, 
      they are required
    - CVE-2023-39327

 -- Bruce Cable <bruce.cable@canonical.com>  Wed, 25 Sep 2024 12:59:17 +1000

openjpeg2 (2.3.1-1ubuntu4.20.04.1) focal-security; urgency=medium

  * SECURITY UPDATE: use-after-free via directory
    - debian/patches/CVE-2020-15389.patch: fix double-free on input
      directory with mix of valid and invalid images in
      src/bin/jp2/opj_decompress.c.
    - CVE-2020-15389
  * SECURITY UPDATE: heap-buffer-overflow
    - debian/patches/CVE-2020-27814-1.patch: grow buffer size in
      src/lib/openjp2/tcd.c.
    - debian/patches/CVE-2020-27814-2.patch: grow it again
    - debian/patches/CVE-2020-27814-3.patch: and some more
    - debian/patches/CVE-2020-27814-4.patch: bigger, BIGGER!!!
    - CVE-2020-27814
  * SECURITY UPDATE: heap-buffer-overflow write
    - debian/patches/CVE-2020-27823.patch: fix wrong computation in
      src/bin/jp2/convertpng.c.
    - CVE-2020-27823
  * SECURITY UPDATE: global-buffer-overflow
    - debian/patches/CVE-2020-27824.patch: avoid global buffer overflow on
      irreversible conversion when too many decomposition levels are
      specified in src/lib/openjp2/dwt.c.
    - CVE-2020-27824
  * SECURITY UPDATE: out-of-bounds read
    - debian/patches/CVE-2020-27841.patch: add extra checks to
      src/lib/openjp2/pi.c, src/lib/openjp2/pi.h, src/lib/openjp2/t2.c.
    - CVE-2020-27841
  * SECURITY UPDATE: null pointer dereference
    - debian/patches/CVE-2020-27842.patch: add check to
      src/lib/openjp2/t2.c.
    - CVE-2020-27842
  * SECURITY UPDATE: out-of-bounds read
    - debian/patches/CVE-2020-27843.patch: add check to
      src/lib/openjp2/t2.c.
    - CVE-2020-27843
  * SECURITY UPDATE: out-of-bounds read
    - debian/patches/CVE-2020-27845.patch: add extra checks to
      src/lib/openjp2/pi.c.
    - CVE-2020-27845

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 06 Jan 2021 09:44:46 -0500

openjpeg2 (2.3.1-1ubuntu4) focal; urgency=medium

  * SECURITY UPDATE: denial of service via excessive iteration
    - debian/patches/CVE-2019-12973-1.patch: detect invalid file dimensions
      early in src/bin/jp2/convertbmp.c.
    - debian/patches/CVE-2019-12973-2.patch: avoid potential infinite loop
      in src/bin/jp2/convertbmp.c.
    - CVE-2019-12973
  * SECURITY UPDATE: heap overflow in opj_t1_clbl_decode_processor
    - debian/patches/CVE-2020-6851.patch: reject images whose
      coordinates are beyond INT_MAX in src/lib/openjp2/j2k.c.
    - CVE-2020-6851
  * SECURITY UPDATE: another heap overflow in opj_t1_clbl_decode_processor
    - debian/patches/CVE-2020-8112.patch: avoid integer overflow in
      src/lib/openjp2/tcd.c.
    - CVE-2020-8112

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 19 Feb 2020 09:52:00 -0500

openjpeg2 (2.3.1-1ubuntu3) focal; urgency=medium

  * Actually omit libopenjpip-server, not libkate-tools which is not in
    this package.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 17 Feb 2020 09:39:20 -0800

openjpeg2 (2.3.1-1ubuntu2) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 10 Feb 2020 08:14:07 +0100

openjpeg2 (2.3.1-1ubuntu1) focal; urgency=medium

  * Omit libopenjpip-server on i386, we only want the libraries for
    compatibility.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Jan 2020 14:52:51 -0800

openjpeg2 (2.3.1-1) unstable; urgency=medium

  * New upstream release, addressing following security issues:
    - CVE-2018-20847 (Closes: #931294)
    - CVE-2018-21010 (Closes: #939553)
    - CVE-2018-5727 (Closes: #888532)
  * Remove following patches, applied upstream:
    - CVE-2017-17480.patch
    - CVE-2018-14423.patch
    - CVE-2018-18088.patch
    - CVE-2018-5785.patch
    - CVE-2018-6616.patch
  * Remove debian/patches/multiarch_path.patch:
    - useless since latest upstream changes.
  * Bump Standards-Version to 4.4.1.
  * Refresh and rework manpages.
  * Remove debian/README.source (Closes: #846390).

 -- Hugo Lefeuvre <hle@debian.org>  Mon, 07 Oct 2019 13:46:43 +0200

openjpeg2 (2.3.0-3) unstable; urgency=medium

  [ Helmut Grohne ]
  * Demote java dependencies to Build-Depends-Indep. (Closes: #870644)

  [ Mathieu Malaterre ]
  * debian/control: update URLs to new salsa location

 -- Mathieu Malaterre <malat@debian.org>  Mon, 30 Sep 2019 15:17:58 +0200
